<?php
/**
 * @file
 * Datex date formatter for views.
 */

/**
 * Date field handler for views with datex support.
 */
class datex_handler_field_date extends views_handler_field_date {
  /**
   * Called by views to render field.
   */
  public function render($values) {
    static $check_array = array(
      'raw time ago',
      'time ago',
      'raw time hence',
      'time hence',
      'raw time span',
      'inverse time span',
      'time span',
    );

    $format = $this->options['date_format'];

    // In this cases, Everything will be handled properly by parent and there
    // is no need for datex to interfere with views original handler.
    if (
      _datex_skip_language() ||
      in_array($format, $check_array) ||
      _datex_integration_mode(DATEX_PATCHING_METHOD)) {
      return parent::render($values);
    }

    if ($value = $this->get_value($values)) {
      $format = ($format === 'custom') ? $this->options['custom_date_format'] : variable_get('date_format_' . $format);
      $timezone = !empty($this->options['timezone']) ? $this->options['timezone'] : drupal_get_user_timezone();
      return DatexFormatter::format($value, $format, $timezone, _datex_intl());
    }
  }
}
